unit Volumeunit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ButtonAjusterVolumeWAV: TButton;
    Panel2: TPanel;
    ButtonRecupVolumeWAVE: TButton;
    Label1: TLabel;
    Label5: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Button1: TButton;
    ButtonRecupVolumeMIDI: TButton;
    TrackBarVolGaucheWave: TTrackBar;
    TrackBarVolDroitWave: TTrackBar;
    TrackBarVolGaucheMidi: TTrackBar;
    TrackBarVolDroitMidi: TTrackBar;
    procedure ButtonAjusterVolumeWAVClick(Sender: TObject);
    procedure ButtonRecupVolumeWAVEClick(Sender: TObject);
    procedure ButtonRecupVolumeMIDIClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}




uses mmsystem;

/////////////////////////////////////////////////////
// pour les WAVE /////////////////////////////////////
/////////////////////////////////////////////////////


procedure SetWaveVolume(Volume: DWord);
var
  Caps : TWAVEOUTCAPS;
begin
  // rcupration des caractristiques du device dans Caps
  if WaveOutGetDevCaps(WAVE_MAPPER, @Caps, sizeof(Caps)) =MMSYSERR_NOERROR
  then
    // si le device supporte le rglage du volumes
    if Caps.dwSupport and WAVECAPS_VOLUME = WAVECAPS_VOLUME then
    //alors affectation du volume.
      WaveOutSetVolume(WAVE_MAPPER, Volume);
end;

procedure TForm1.ButtonAjusterVolumeWAVClick(Sender: TObject);
var
  VolumeCanalGauche: Word;
  VolumeCanalDroite: Word;
begin
  VolumeCanalGauche := TrackBarVolGaucheWave.Position;
  VolumeCanalDroite := TrackBarVolDroitWave.Position;
  // MakeLong cre un DWord en concatnant 2 Word
  SetWaveVolume(MakeLong(VolumeCanalGauche, VolumeCanalDroite));
end;

procedure TForm1.ButtonRecupVolumeWAVEClick(Sender: TObject);
type
TvolumeStereo=
  record
   gauche:word; // volume du canal de gauche
   droite:word;  // volume du canal de droite
  end;
var
  Caps : TWAVEOUTCAPS;
  volumeStereo:  TvolumeStereo;
  volumeDWord:DWord absolute VolumeStereo;
  // absolute veut dire que la variable volumeDWord se place exactement au
  // mme emplacement mmoire que VolumeStereo.
  // ainsi lorsque VolumeDword prendra une certaine valeur, VolumeStereo sera
  // automatiquement modifi en consquence.
  // la manire dont sont stocks le canal droit et le canal gauche dans
  // VolumeDWord fait que les emplacement mmoire corespondent 
  // gauche et droite de VolumeStereo.
begin
  // rcupration des caractristiques du device dans Caps
  if (WaveOutGetDevCaps(WAVE_MAPPER, @Caps, sizeof(Caps)) =MMSYSERR_NOERROR) then
  // si le device supporte le rglage du volumes
    if Caps.dwSupport and WAVECAPS_VOLUME = WAVECAPS_VOLUME then
      // alors rcupration de la valeur du volume
      WaveOutGetVolume(WAVE_MAPPER, @VolumeDWord);
  Label4.Caption := IntToStr(VolumeDWord);
  // ajustement des TrackBar en fonction des volumes des canaux
  TrackBarVolGaucheWave.Position:=volumeStereo.gauche;
  TrackBarVolDroitWave.Position:=volumeStereo.droite;
end;


/////////////////////////////////////////////////////
// pour les MIDI ////////////////////////////////////
// attention, un MIDI doit tre en train de jouer
/////////////////////////////////////////////////////



procedure SetMidiVolume(Volume: DWord);
var
  Caps : TMidiOUTCAPS;
begin
  if MidiOutGetDevCaps(MIDI_MAPPER, @Caps, sizeof(Caps)) =MMSYSERR_NOERROR
  then
    if Caps.dwSupport and MIDICAPS_VOLUME = MIDICAPS_VOLUME then
      MidiOutSetVolume(WAVE_MAPPER, Volume);
end;

procedure TForm1.ButtonRecupVolumeMIDIClick(Sender: TObject);
type
TvolumeStereo=
  record
   gauche:word; // volume du canal de gauche
   droite:word;  // volume du canal de droite
  end;
var
  Caps : TMidiOUTCAPS;
  volumeStereo:  TvolumeStereo;
  volumeDWord:DWord absolute VolumeStereo;
begin
  if MidiOutGetDevCaps(MIDI_MAPPER, @Caps, sizeof(Caps))=MMSYSERR_NOERROR
  then
    if Caps.dwSupport and MIDICAPS_VOLUME = MIDICAPS_VOLUME then
           MidiOutGetVolume(MIDI_MAPPER, @VolumeDWord);
  Label10.Caption := IntToStr(VolumeDWord);
  TrackBarVolGaucheMidi.Position:=volumeStereo.gauche;
  TrackBarVolDroitMidi.Position:=volumeStereo.droite;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  LeftVolume: Word;
  RightVolume: Word;
begin
  LeftVolume := TrackBarVolGaucheMidi.Position;
  RightVolume := TrackBarVolDroitMidi.Position;
  SetMidiVolume(MakeLong(LeftVolume, RightVolume));
end;


end.
